2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
6 # SPDX-License-Identifier: GPL-2.0+
10 # if exiting with 0, write to stdout, else write to stderr
12 [ "${ret}" -eq 1 ] && exec 1>&2
14 Usage: MAKEALL [options] [--] [boards-to-build]
17 -a ARCH, --arch ARCH Build all boards with arch ARCH
18 -c CPU, --cpu CPU Build all boards with cpu CPU
19 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
20 -s SOC, --soc SOC Build all boards with soc SOC
21 -b BOARD, --board BOARD Build all boards with board name BOARD
22 -l, --list List all targets to be built
23 -m, --maintainers List all targets and maintainer email
24 -M, --mails List all targets and all affilated emails
25 -C, --check Enable build checking
26 -n, --continue Continue (skip boards already built)
27 -r, --rebuild-errors Rebuild any boards that errored
28 -h, --help This help output
30 Selections by these options are logically ANDed; if the same option
31 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
32 will select all configurations where the vendor is either FOO or
33 BAR. Any additional arguments specified on the command line are
34 always build additionally. See the boards.cfg file for more info.
36 If no boards are specified, then the default is "powerpc".
38 Environment variables:
39 BUILD_NCPUS number of parallel make jobs (default: auto)
40 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
41 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
42 architecture "ARCH". Substitute "ARCH" for any
43 supported architecture (default: "")
44 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
45 BUILD_DIR output build directory (default: ./)
46 BUILD_NBUILDS number of parallel targets (default: 1)
49 - build all Power Architecture boards:
51 MAKEALL --arch powerpc
53 - build all PowerPC boards manufactured by vendor "esd":
54 MAKEALL -a powerpc -v esd
55 - build all PowerPC boards manufactured either by "keymile" or "siemens":
56 MAKEALL -a powerpc -v keymile -v siemens
57 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
58 MAKEALL -c mpc83xx -v freescale 4xx
63 SHORT_OPTS="ha:c:v:s:b:lmMCnr"
64 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,board:,list,maintainers,mails,check,continue,rebuild-errors"
66 # Option processing based on util-linux-2.13/getopt-parse.bash
68 # Note that we use `"$@"' to let each command-line parameter expand to a
69 # separate word. The quotes around `$@' are essential!
70 # We need TEMP as the `eval set --' would nuke the return value of
72 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
75 [ $? != 0 ] && usage 1
77 # Note the quotes around `$TEMP': they are essential!
90 # echo "Option ARCH: argument \`$2'"
91 if [ "$opt_a" ] ; then
92 opt_a="${opt_a%)} || \$2 == \"$2\")"
94 opt_a="(\$2 == \"$2\")"
99 # echo "Option CPU: argument \`$2'"
100 if [ "$opt_c" ] ; then
101 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
103 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
108 # echo "Option SoC: argument \`$2'"
109 if [ "$opt_s" ] ; then
110 opt_s="${opt_s%)} || \$4 == \"$2\" || \$4 ~ /$2/)"
112 opt_s="(\$4 == \"$2\" || \$4 ~ /$2/)"
117 # echo "Option VENDOR: argument \`$2'"
118 if [ "$opt_v" ] ; then
119 opt_v="${opt_v%)} || \$5 == \"$2\")"
121 opt_v="(\$5 == \"$2\")"
126 # echo "Option BOARD: argument \`$2'"
127 if [ "$opt_b" ] ; then
128 opt_b="${opt_b%)} || \$6 == \"$2\" || \$7 == \"$2\")"
130 # We need to check the 7th field too
131 # for boards whose 6th field is "-"
132 opt_b="(\$6 == \"$2\" || \$7 == \"$2\")"
162 echo "Internal error!" >&2 ; exit 1 ;;
166 GNU_MAKE=$(scripts/show-gnu-make) || {
167 echo "GNU Make not found" >&2
171 # echo "Remaining arguments:"
172 # for arg do echo '--> '"\`$arg'" ; done
174 tools/genboardscfg.py || {
175 echo "Failed to generate boards.cfg" >&2
180 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
181 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
182 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
183 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
184 [ "$opt_b" ] && FILTER="${FILTER} && $opt_b"
186 if [ "$SELECTED" ] ; then
187 SELECTED=$(awk '('"$FILTER"') { print $7 }' boards.cfg)
189 # Make sure some boards from boards.cfg are actually found
190 if [ -z "$SELECTED" ] ; then
191 echo "Error: No boards selected, invalid arguments"
196 #########################################################################
198 # Print statistics when we exit
202 # Determine number of CPU cores if no default was set
203 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
205 if [ "$BUILD_NCPUS" -gt 1 ]
207 JOBS="-j $((BUILD_NCPUS + 1))"
212 if [ "${MAKEALL_LOGDIR}" ] ; then
213 LOG_DIR=${MAKEALL_LOGDIR}
218 : ${BUILD_NBUILDS:=1}
221 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
223 : ${BUILD_DIR:=./build}
224 mkdir -p "${BUILD_DIR}/ERR"
225 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
230 OUTPUT_PREFIX="${BUILD_DIR}"
232 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
233 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
234 find "${LOG_DIR}/" -type f -exec rm -f {} +
239 # Keep track of the number of builds and errors
250 # Helper funcs for parsing boards.cfg
256 awk '($1 !~ /^#/ && $'"$field"' ~ /^'"$regexp"'$/) { print $7 }' \
260 targets_by_arch() { targets_by_field 2 "$@" ; }
261 targets_by_cpu() { targets_by_field 3 "$@" ; targets_by_field 3 "$@:.*" ; }
262 targets_by_soc() { targets_by_field 4 "$@" ; }
264 #########################################################################
266 #########################################################################
268 LIST_5xx="$(targets_by_cpu mpc5xx)"
270 #########################################################################
272 #########################################################################
274 LIST_5xxx="$(targets_by_cpu mpc5xxx)"
276 #########################################################################
278 #########################################################################
280 LIST_512x="$(targets_by_cpu mpc512x)"
282 #########################################################################
284 #########################################################################
286 LIST_8xx="$(targets_by_cpu mpc8xx)"
288 #########################################################################
290 #########################################################################
292 LIST_4xx="$(targets_by_cpu ppc4xx)"
294 #########################################################################
295 ## MPC8260 Systems (includes 8250, 8255 etc.)
296 #########################################################################
298 LIST_8260="$(targets_by_cpu mpc8260)"
300 #########################################################################
301 ## MPC83xx Systems (includes 8349, etc.)
302 #########################################################################
304 LIST_83xx="$(targets_by_cpu mpc83xx)"
306 #########################################################################
307 ## MPC85xx Systems (includes 8540, 8560 etc.)
308 #########################################################################
310 LIST_85xx="$(targets_by_cpu mpc85xx)"
312 #########################################################################
314 #########################################################################
316 LIST_86xx="$(targets_by_cpu mpc86xx)"
318 #########################################################################
320 #########################################################################
322 LIST_74xx_7xx="$(targets_by_cpu 74xx_7xx)"
324 #########################################################################
326 #########################################################################
348 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
349 # still using "ppc" instead of "powerpc"
354 #########################################################################
356 #########################################################################
358 LIST_SA="$(targets_by_cpu sa1100)"
360 #########################################################################
362 #########################################################################
364 LIST_ARM7="$(targets_by_cpu arm720t)"
366 #########################################################################
368 #########################################################################
370 LIST_ARM9="$(targets_by_cpu arm920t) \
371 $(targets_by_cpu arm926ejs) \
372 $(targets_by_cpu arm946es) \
375 #########################################################################
377 #########################################################################
378 LIST_ARM11="$(targets_by_cpu arm1136) \
379 $(targets_by_cpu arm1176) \
382 #########################################################################
384 #########################################################################
386 LIST_ARMV7="$(targets_by_cpu armv7)"
388 #########################################################################
390 #########################################################################
392 LIST_ARMV8="$(targets_by_cpu armv8)"
394 #########################################################################
396 #########################################################################
398 LIST_at91="$(targets_by_soc at91)"
400 #########################################################################
402 #########################################################################
404 LIST_pxa="$(targets_by_cpu pxa)"
406 #########################################################################
408 #########################################################################
410 LIST_spear="$(targets_by_soc spear)"
412 #########################################################################
414 #########################################################################
416 LIST_arm="$(targets_by_arch arm | \
417 for ARMV8_TARGET in $LIST_ARMV8; \
418 do sed "/$ARMV8_TARGET/d"; \
422 #########################################################################
423 ## MIPS Systems (default = big endian)
424 #########################################################################
426 LIST_mips="$(targets_by_arch mips)"
428 #########################################################################
430 #########################################################################
432 LIST_openrisc="$(targets_by_arch openrisc)"
434 #########################################################################
436 #########################################################################
438 LIST_x86="$(targets_by_arch x86)"
440 #########################################################################
442 #########################################################################
444 LIST_nios2="$(targets_by_arch nios2)"
446 #########################################################################
447 ## MicroBlaze Systems
448 #########################################################################
450 LIST_microblaze="$(targets_by_arch microblaze)"
452 #########################################################################
454 #########################################################################
456 LIST_m68k="$(targets_by_arch m68k)"
457 LIST_coldfire=${LIST_m68k}
459 #########################################################################
461 #########################################################################
463 LIST_avr32="$(targets_by_arch avr32)"
465 #########################################################################
467 #########################################################################
469 LIST_blackfin="$(targets_by_arch blackfin)"
471 #########################################################################
473 #########################################################################
475 LIST_sh2="$(targets_by_cpu sh2)"
476 LIST_sh3="$(targets_by_cpu sh3)"
477 LIST_sh4="$(targets_by_cpu sh4)"
479 LIST_sh="$(targets_by_arch sh)"
481 #########################################################################
483 #########################################################################
485 LIST_sparc="$(targets_by_arch sparc)"
487 #########################################################################
489 #########################################################################
491 LIST_nds32="$(targets_by_arch nds32)"
493 #########################################################################
495 #########################################################################
497 LIST_arc="$(targets_by_arch arc)"
499 #-----------------------------------------------------------------------
501 get_target_location() {
509 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
510 if [ -z "${line}" ] ; then echo "" ; return ; fi
514 CONFIG_NAME="${7%_defconfig}"
516 [ "${BOARD_NAME}" ] || BOARD_NAME="${7%_defconfig}"
518 if [ $# -gt 5 ]; then
519 if [ "$6" = "-" ] ; then
526 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
527 [ $# -gt 6 ] && [ "$8" != "-" ] && {
534 # Assign board directory to BOARDIR variable
535 if [ "${vendor}" == "-" ] ; then
538 BOARDDIR=${vendor}/${board}
541 echo "${CONFIG_NAME}:${BOARDDIR}:${BOARD_NAME}"
544 get_target_maintainers() {
545 local name=`echo $1 | cut -d : -f 3`
547 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
548 if [ -z "${line}" ]; then
553 local mails=`echo ${line} | cut -d ' ' -f 9- | sed -e 's/[^<]*<//' -e 's/>.*</ /' -e 's/>[^>]*$//'`
554 [ "$mails" == "-" ] && mails=""
562 local line=`awk '\$7 == "'"$target"'" { print \$0 }' boards.cfg`
564 if [ -z "${line}" ] ; then echo "" ; return ; fi
571 if [ "$PRINT_MAINTS" != 'y' ] ; then
578 local loc=`get_target_location $1`
580 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
582 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
584 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
586 local dir=`echo ${loc} | cut -d ":" -f 2`
587 local cfg=`echo ${loc} | cut -d ":" -f 1`
588 local git_result=`git log --format=%aE board/${dir} \
589 include/configs/${cfg}.h | grep "@"`
590 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
592 local git_result_top=`echo ${git_result} | tr " " "\n" | \
593 sort | uniq -c | sort -nr | head -n 3 | \
594 sed "s/^ \+[0-9]\+ \+//"`
596 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
597 sort -u | tr "\n" " " | sed "s/ $//" ;
599 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
606 # Each finished build will have a file called ${donep}${n},
607 # where n is the index of the build. Each build
608 # we've already noted as finished will have ${skipp}${n}.
609 # The code managing the build process will use this information
610 # to ensure that only BUILD_NBUILDS builds are in flight at once
611 donep="${LOG_DIR}/._done_"
612 skipp="${LOG_DIR}/._skip_"
614 build_target_killed() {
615 echo "Aborted $target build."
616 # Remove the logs for this board since it was aborted
617 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
625 if [ "$ONLY_LIST" == 'y' ] ; then
626 list_target ${target}
630 if [ $BUILD_MANY == 1 ] ; then
631 output_dir="${OUTPUT_PREFIX}/${target}"
632 mkdir -p "${output_dir}"
633 trap build_target_killed TERM
635 output_dir="${OUTPUT_PREFIX}"
638 target_arch=$(get_target_arch ${target})
639 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
640 if [ "${cross_toolchain}" ] ; then
641 MAKE="$GNU_MAKE CROSS_COMPILE=${cross_toolchain}"
642 elif [ "${CROSS_COMPILE}" ] ; then
643 MAKE="$GNU_MAKE CROSS_COMPILE=${CROSS_COMPILE}"
648 if [ "${output_dir}" != "." ] ; then
649 MAKE="${MAKE} O=${output_dir}"
652 ${MAKE} mrproper >/dev/null
654 echo "Building ${target} board..."
655 ${MAKE} -s ${target}_defconfig >/dev/null
657 ${MAKE} ${JOBS} ${CHECK} all \
658 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
660 # Check for 'make' errors
661 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
665 if [ $BUILD_MANY == 1 ] ; then
670 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
671 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
673 rm ${LOG_DIR}/${target}.ERR
676 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
677 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
678 : $(( ERR_CNT += 1 ))
679 ERR_LIST="${ERR_LIST} $target"
681 : $(( WRN_CNT += 1 ))
682 WRN_LIST="${WRN_LIST} $target"
685 rm ${LOG_DIR}/${target}.ERR
689 OBJS=${output_dir}/u-boot
690 if [ -e ${output_dir}/spl/u-boot-spl ]; then
691 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
694 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
696 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
698 touch "${donep}${build_idx}"
702 search_idx=${OLDEST_IDX}
703 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
706 if [ -e "${donep}${search_idx}" ] ; then
707 : $(( CURRENT_CNT-- ))
708 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
709 : $(( OLDEST_IDX++ ))
711 # Only want to count it once
712 rm -f "${donep}${search_idx}"
713 touch "${skipp}${search_idx}"
714 elif [ -e "${skipp}${search_idx}" ] ; then
715 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
716 : $(( OLDEST_IDX++ ))
718 : $(( search_idx++ ))
719 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
720 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
721 search_idx=${OLDEST_IDX}
732 # If a LIST_xxx var exists, use it. But avoid variable
733 # expansion in the eval when a board name contains certain
734 # characters that the shell interprets.
737 *) list=$(eval echo '${LIST_'$t'}') ;;
739 if [ -n "${list}" ] ; then
740 build_targets ${list}
742 : $((TOTAL_CNT += 1))
743 : $((CURRENT_CNT += 1))
744 rm -f "${donep}${TOTAL_CNT}"
745 rm -f "${skipp}${TOTAL_CNT}"
746 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
748 touch "${donep}${TOTAL_CNT}"
749 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
751 touch "${donep}${TOTAL_CNT}"
753 if [ $BUILD_MANY == 1 ] ; then
754 build_target ${t} ${TOTAL_CNT} &
757 build_target ${t} ${TOTAL_CNT}
763 # We maintain a running count of all the builds we have done.
764 # Each finished build will have a file called ${donep}${n},
765 # where n is the index of the build. Each build
766 # we've already noted as finished will have ${skipp}${n}.
767 # We track the current index via TOTAL_CNT, and the oldest
768 # index. When we exceed the maximum number of parallel builds,
769 # We look from oldest to current for builds that have completed,
770 # and update the current count and oldest index as appropriate.
771 # If we've gone through the entire list, wait a second, and
772 # reprocess the entire list until we find a build that has
774 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
780 #-----------------------------------------------------------------------
787 # Mac OS X is known to have BSD style ps
788 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
789 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
792 # everything else tries the GNU style
793 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
794 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
798 kill $children 2> /dev/null
799 wait $children 2> /dev/null
805 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
807 # Only count boards that completed
808 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
810 rm -f ${donep}* ${skipp}*
812 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
813 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
814 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
815 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
816 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
817 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
818 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
820 # Remove the logs for any board that was interrupted
821 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
824 : $((TOTAL_CNT -= ${SKIP_CNT}))
826 echo "--------------------- SUMMARY ----------------------------"
827 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
828 echo "Boards skipped: ${SKIP_CNT}"
830 echo "Boards compiled: ${TOTAL_CNT}"
831 if [ ${ERR_CNT} -gt 0 ] ; then
832 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
834 if [ ${WRN_CNT} -gt 0 ] ; then
835 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
837 echo "----------------------------------------------------------"
839 if [ $BUILD_MANY == 1 ] ; then
846 #-----------------------------------------------------------------------
848 # Build target groups selected by options, plus any command line args
849 set -- ${SELECTED} "$@"
850 # run PowerPC by default
851 [ $# = 0 ] && set -- powerpc